﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Add a reference to System.ServiceProcess.
using System.ServiceProcess;

namespace howto_restart_print_spooler
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnRestart_Click(object sender, EventArgs e)
        {
            Cursor = Cursors.WaitCursor;

            // Stop the spooler.
            ServiceController service = new ServiceController("Spooler");
            if ((!service.Status.Equals(ServiceControllerStatus.Stopped)) &&
                (!service.Status.Equals(ServiceControllerStatus.StopPending)))
            {
                lblStatus.Text = "Stopping spooler...";
                lblStatus.Refresh();

                service.Stop();
                service.WaitForStatus(ServiceControllerStatus.Stopped);
            }

            // Start the spooler.
            lblStatus.Text = "Restarting spooler...";
            lblStatus.Refresh();
            service.Start();
            service.WaitForStatus(ServiceControllerStatus.Running);

            lblStatus.Text = "Done";
            Cursor = Cursors.Default;
        }
    }
}
